function [Ac, P, a0] = chmp_easy(m,n,p)

    %% generating m random points in the unit ball in Rn
    Ac = zeros(n,p);
    P = zeros(n,m);
    
    for i=1:p
       v = randn(n,1);
       v = v/norm(v,2);
       Ac(:,i) = (rand()^(1/n))*v;
    end
    
    %% generating p in conv(Ac) 
    [~,I] = sort(Ac(1,:),'descend');

    v1 = Ac(:,I(1));
    v2 = Ac(:,I(2));
    
    for j=1:m
       q = rand;
       pp = q*v1 + (1-q)*v2;
       pp = pp/norm(pp,2);
       pp = 1.001*pp;
       P(:,j) = pp;
    end
    
    a0 = zeros(p,1);
    a0(1)=1;
end