function [Ac, P, a0] = chmp_hard(m,n,p)

    %% generating m random points in the unit ball in Rn
    Ac = zeros(n,p);
    P = zeros(n,m);
    
    for i=1:p
       v = randn(n,1);
       v = v/norm(v,2);
       Ac(:,i) = (rand()^(1/n))*v;
    end
    
    %% generating p in conv(Ac) 
    [~,I] = sort(Ac(1,:),'descend');

    v1 = Ac(:,I(1));
    v2 = Ac(:,I(2));
    
    p1 = 0.5*v1 + 0.5*v2;
    
    P(:,1) = p1;
    
    for j=2:m
       pp = p1 + 1e-2*randn(n,1);
       pp = pp/norm(pp,2);
       pp = 1.001*pp;
       P(:,j) = pp;
    end
    
    a0 = zeros(p,1);
    a0(1)=1;
end