function [] = pprofile(A,legenda,colors)
%
% Example: pprofile(A,{'data1','data2'},['r', 'b'],1,10)
%
% The columns of A correspond to each solver and the rows to each problem
%

lines   = [':' '-' '-.' '--'];
markers = ['x' '*' 's' 'd' 'v' '^' 'o'];

% p problems, m solvers
[p,m] = size(A);

% minimum resources
mini = min(A,[],2);

% performance ratios
M = A;
for i=1:p
   M(i,:) = M(i,:)/mini(i); 
end

maxM = max(max(M));

scrsz = get(0,'ScreenSize');
figure('Position',[1 scrsz(4)/2 scrsz(3)/2 scrsz(4)/2]);

hold on

%% using CDF plot

% % % % cumulative for performance ratios
% % % for j=1:m
% % %     cdfplotc(M(:,j),colors(j))
% % % end

%% using *stairs* (do not require cdfplot, cdfcalc functions from Stat toolbox)

% Replace all NaN's with twice the max_ratio and sort.
% 
M(find(isnan(M))) = 2*maxM;
M = sort(M);

% Plot stair graphs with markers.
clf;
for s = 1:m
 [xs,ys] = stairs(M(:,s), (1:p)./p);
 
 % correction when xs(1) > 1
 if (xs(1)>1)
    xs = [1; xs(1); xs];
    ys = [0; 0; ys];
 end
 
 xs = [xs; 1.2*maxM;];
 ys = [ys; ys(end)];
 
 % remove the first stair in the plot
 id1 = max(find(xs==1));
     
 %option = ['-' colors(s) markers(s)];
 option = ['-' colors(s)];
 plot(xs(id1:end),ys(id1:end),option,'MarkerSize',3);
 hold on;
end

% figure properties
box on
x0 = 1;
x1 = 1.1*maxM;
axis([x0 x1 0 1]);
%set(gca,'XTick',x0:0.5:x1);
h = legend(legenda,'Location','SouthEast');
set(h,'Interpreter','none')

xlabel('t')
ylabel('\rho_s(t)')
title ('Performance Profile')