% random experiments: multi-objective Fermat-Weber problem (Section 4.2)
clear;
rng(123);

n = [2 2 2 3 3 3 3];
m = [3 3 3 5 5 5 5];
%p = [50 100 500 50 100 500 1000];
p = [500 1000 2000 500 1000 2000 3000]; % for large p CSD/quadprog becomes heavy...

r=20;

np = length(n);

T = zeros(np, 15);

t1 = [];
t2 = [];
t3 = [];

for i=1:np
   nn = n(i);
   mm = m(i);
   pp = p(i);
   
   T(i,1)=nn; T(i,2)=mm; T(i,3)=pp;
   
   iter1 = zeros(r,1);
   iter2 = zeros(r,1);
   iter3 = zeros(r,1);
   time1 = zeros(r,1);
   time2 = zeros(r,1);
   time3 = zeros(r,1);
   
   fprintf('Problem # %d \n', i);
   
   for j=1:r
       fprintf('Run # %d \n', j);
       [Ac, P, a0] = chmp_hard(mm,nn,pp);
       tic;
       [x,F,k,fe,flag] = ASFW(@(x) fermat(x,P), 1, Ac, a0,1e-6,5000,0,0);
       time1(j) = toc;
       iter1(j) = k;
       tic;
       [x,F,k,fe,flag] = ASFW(@(x) fermat(x,P), 1, Ac, a0,1e-6,5000,1,0);
       time2(j) = toc;
       iter2(j) = k;
       tic;
       [x,F,k,fe,flag,~,tstop] = CSD(@(x) fermat(x,P), 1, Ac, a0, 1e-6, 5000);
       time3(j) = toc;
       time3(j) = time3(j) - tstop;
       iter3(j) = k;
   end
   
   T(i,4) = min(iter1); T(i,5) = mean(iter1); T(i,6) = max(iter1);
   T(i,7) = min(iter2); T(i,8) = mean(iter2); T(i,9) = max(iter2);
   T(i,10) = min(iter3); T(i,11) = mean(iter3); T(i,12) = max(iter3);
   
   t1 = [t1; time1];
   t2 = [t2; time2];
   t3 = [t3; time3];
   
end