% random experiments: multi-objective quadratics (Section 4.3)
clear;
rng(123);

n = [120 150 200 300 400]; %[10 20 40 80 160];
m = [6 7 8 9 10]; %[2 3 4 5 6];

r=10;

np = length(n);

T = zeros(np, 12);

t1 = []; it1 = [];
t2 = []; it2 = [];
t3 = []; it3 = [];

for i=1:np
   nn = n(i);
   mm = m(i);
   pp = 2*nn;
   
   Ac = [-eye(nn) eye(nn)];
   A = cell(mm,1);
   B = zeros(nn,mm);
   L = 0;
   
   for l=1:mm
       
       D = diag(abs(10*randn(nn,1)));
       if max(diag(D))^2 > L
           L = max(diag(D))^2; 
       end
       
       A{l} = D; % diagonal positive definite
       
%        Y = 5*randn(nn);
%        Z = Y'*Y; 
%        Z = 0.5*(Z + Z');
%        A{l} = Z;
%        normA = norm(A{l},2);
%        if normA^2 > L
%            L = normA^2; 
%        end       
       
       xs = rand(nn,1);
       idx = randi(nn);
       xs(idx) = 0; % unconstrained minimizer of each objective outside ||x||_1 <= 1
       xs(idx) = (1 - sum(xs));
       B(:,l) = A{l}*xs;
   end
   
   T(i,1)=nn; T(i,2)=mm; T(i,3)=pp;
   
   iter1 = zeros(r,1);
   iter2 = zeros(r,1);
   iter3 = zeros(r,1);
   time1 = zeros(r,1);
   time2 = zeros(r,1);
   time3 = zeros(r,1);
   
   fprintf('Problem # %d \n', i);
   
   for j=1:r
       fprintf('Run # %d \n', j);
       
       w = rand(2*nn,1);
       a0 = projsplx(w);
       a0 = max(a0,0);
       a0 = a0./sum(a0);
       
%        time1(j) = 0; iter1(j) = 0;
%        tic;
%        [x,F,k,fe,flag] = ASFW(@(x) toyfunG(x,A,B,nn,mm), L, Ac, a0,1e-4,2000,0,0);
%        time1(j) = toc;
%        iter1(j) = k;
       
       tic;
       [x,F,k,fe,flag2] = ASFW(@(x) toyfunG(x,A,B,nn,mm), L, Ac, a0,1e-4,2000,1,0);
       time2(j) = toc;
       iter2(j) = k;
       
       tic;
       [x,F,k,fe,flag3,~,tstop] = CSD(@(x) toyfunG(x,A,B,nn,mm), L, Ac, a0, 1e-4, 2000);
       time3(j) = toc;
       time3(j) = time3(j) - tstop;
       iter3(j) = k;
   end
   
   T(i,4) = min(iter1); T(i,5) = mean(iter1); T(i,6) = max(iter1);
   T(i,7) = min(iter2); T(i,8) = mean(iter2); T(i,9) = max(iter2);
   T(i,10) = min(iter3); T(i,11) = mean(iter3); T(i,12) = max(iter3);
   
   t1 = [t1; time1];
   it1 = [it1; iter1];
   t2 = [t2; time2];
   it2 = [it2; iter2];
   t3 = [t3; time3];
   it3 = [it3; iter3];
   
end