%% script for Toy Problem (Section 4.1)
load toy;

% Draw level sets and feasible set
f = @(x,y) 0.5*norm(A*[x; y] - b,2).^2;
g = @(x,y) 0.5*norm(A*[x; y] - c,2).^2;
fcontour(f,[-1.5 1 -1.5 1],'LevelList',[0 1 2 4 8]);
hold on
fcontour(g,'--',[-1.5 1 -1.5 1],'LevelList',[0 1 2 4 8])
P = [A\b A\c];
plot(P(1,:),P(2,:),'r.-');
Acc = [Ac Ac(:,1)];
plot(Acc(1,:),Acc(2,:),'k.-');

% Plot the trajectories for M-FW and M-AFW

% M-FW
%[x,F,k,fe,flag,xlist] = ASFW(@(x) toyfun(x,A,b,c),norm(A,2)^2,Ac,[1 0 0 0]',1e-8,100,0,0);
[x,F,k,fe,flag,xlist] = CSD(@(x) toyfun(x,A,b,c),norm(A,2)^2,Ac,[1 0 0 0]',1e-8,100);
plot(xlist(:,1),xlist(:,2),'mo-');

% M-AFW
[x,F,k,fe,flag,xlist] = ASFW(@(x) toyfun(x,A,b,c),norm(A,2)^2,Ac,[1 0 0 0]',1e-8,100,1,0);
plot(xlist(:,1),xlist(:,2),'g*-');

