function [F, J] = toyfunG(x,A,B,n,m)
    % A: cell array of matrices A{i} along the 3rd dimension
    % B: n x m matrix whose columns are the vectors b{i}
    %
    % min { 0.5|A{i} x - b{i}|^2 }_{i=1}^m
    % s.t. |x|_1 <= 1
    
    Ax = zeros(n,m);
    res = zeros(n,m);
    F = zeros(m,1);
    
    for i=1:m
        Ax(:,i) = A{i}*x;
        res(:,i) = Ax(:,i) - B(:,i);
        F(i) = 0.5*(res(:,i))'*res(:,i);
    end

    if nargout > 1
        J = zeros(m,n);
        for i=1:m
            J(i,:) = ((A{i})'*res(:,i))';
        end
    end

end